#include <xtl.h>
#include "XKUtils\XKExports.h"
#include "XKUtils\XKUtils.h"
#include "portdefs.h"
#include "engine.h"

int isdigit(int c) {
	return (c >='0' && c <= '9');
}

int isprint(int c) {
	return (c >= ' ' && c <= '~');
}

int isspace(int c) {
	return (c == ' ');
}
////////////////////////////////////////////////////////////////////////////////

typedef struct 
{
	char szDriveLetter;
	char* szDevice;
} stDriveMapping2;

stDriveMapping2 driveMapping[]=
{
	{ 'C', "Harddisk0\\Partition2"},
	{ 'D', "Cdrom0"},
	{ 'E', "Harddisk0\\Partition1"},
	{ 'F', "Harddisk0\\Partition6"},
	{ 'X', "Harddisk0\\Partition3"},
	{ 'Y', "Harddisk0\\Partition4"},
	{ 'Z', "Harddisk0\\Partition5"},
};
#define NUM_OF_DRIVES ( sizeof( driveMapping) / sizeof( driveMapping[0] ) )

char *getxbepath(char *buffer, int maxlen)
{
	PANSI_STRING pImageFileName = (PANSI_STRING)XeImageFileName;
	char szDevicePath[MAX_PATH+1];

	// \Device\Partition0\;
	strncpy(szDevicePath,
			&pImageFileName->Buffer[8],
			pImageFileName->Length - 7 );	//get xbepath (without \Device\ prefix)
	
	for (int i=0; i < NUM_OF_DRIVES; i++)
	{		
		if (!strnicmp(driveMapping[i].szDevice, szDevicePath, strlen(driveMapping[i].szDevice)))
		{			
			buffer[0]=driveMapping[i].szDriveLetter;
			buffer[1]=':';
			strncpy(&buffer[2],
				   &szDevicePath[strlen(driveMapping[i].szDevice)],
				   strlen(szDevicePath)-strlen(driveMapping[i].szDevice));
			buffer[strlen(szDevicePath)-strlen(driveMapping[i].szDevice)+1]=0;
			char* pEnd = strrchr(buffer,'\\');
			if (pEnd!=NULL)
				*pEnd++ = 0;

			return buffer;
		}
	}
	strncpy(buffer, "D:\\", maxlen);
	return buffer;
}

char *getxbefilename(char *buffer, int maxlen)
{
	PANSI_STRING pImageFileName = (PANSI_STRING)XeImageFileName;
	char szDevicePath[MAX_PATH+1];

	strncpy(szDevicePath,
			pImageFileName->Buffer,
			pImageFileName->Length);	//get xbepath (without \Device\ prefix)
	szDevicePath[pImageFileName->Length]=0;

	char* pEnd = strrchr(szDevicePath,'\\');
	pEnd++;

	strcpy(buffer, pEnd);
	
	return buffer;
}


void resetxbe() {
	XKUtils XKUtils;
	char buffer[MAX_PATH];

	PANSI_STRING pImageFileName = (PANSI_STRING)XeImageFileName;
	char szDevicePath[MAX_PATH+1];

	strncpy(szDevicePath,
			pImageFileName->Buffer,
			pImageFileName->Length);
	szDevicePath[pImageFileName->Length]=0;
	char* pEnd = strrchr(szDevicePath,'\\');
	if (pEnd!=NULL)
		*pEnd++ = 0;

	debug(1,"mounting D: to: %s",szDevicePath);
	XKUtils.UnMountDiskD();
	XKUtils.MountDevice(DriveD, szDevicePath);
	strcpy(buffer,"D:\\");
	getxbefilename(&buffer[strlen(buffer)], MAX_PATH);
	debug(1,"launching %s",buffer);
	XLaunchNewImage(buffer, NULL );
}